package state51::BecomeUserIfRoot;
use strict;
use warnings;
use Carp qw/ confess /;
use POSIX qw(setuid setgid);

sub import {
    my ($self, $user) = @_;
    confess("No user passed to state51::BecomeUserIfRoot->import")
        unless $user;
    if ($< == 0) {
        my $uid = getpwnam($user) || do {
            warn("$user does not exist\n");
            return;
        };
        my (undef, undef, undef, $gid ) = getpwuid($uid);
        if ($gid) {
            setgid($gid) || confess("Could not setgid $gid : $!");
        }
        if ($uid) {
            setuid($uid) || confess("Could not setuid $uid : $!");
        }
    }
}

1;

