package state51::Mixin::MemoryLimit;
use state51::Moose::Role;
use BSD::Resource qw/setrlimit getrlimit RLIMIT_VMEM /;

has virtual_memory_hard_max_megs => (
    isa => Int,
    is => 'ro',
    default => 2*1024,
);

sub BUILD {}
before BUILD => sub {
    my $self = shift;
    my $current = getrlimit(RLIMIT_VMEM);
    my $limit = $self->virtual_memory_hard_max_megs() * 1024 * 1024;
    if ($current == -1 or $current > $limit) {
        setrlimit(RLIMIT_VMEM, $limit, $limit);
        warn("Set memory limit to $limit bytes\n") if -t STDIN;
    }
};

1;

