package state51::Moose;
use strict;
use warnings;

use Moose ();
use Moose::Autobox;
use Function::Parameters;
use Moose::Util::TypeConstraints ();
use Moose::Autobox ();
use feature ();
no indirect;
no multidimensional;
no bareword::filehandles;
use Sub::StrictDecl;
use MooseX::Types::Moose ();
use MooseX::Types::Common::String ();
use MooseX::Types::Common::Numeric ();
use MooseX::Types::Varchar ();
use MooseX::Types::ISO8601 ();
use MooseX::Types::LoadableClass ();
use MooseX::Types::DateTime::MySQL ();
sub do_import {
    my $class = shift;
    my $into = shift;
    my @also = @_;

    my ( $import, $unimport, $init_meta ) = Moose::Exporter->build_import_methods(
        into => $into,
        also => [ @also, 'Moose::Util::TypeConstraints' ],
    );
    feature->import(':5.10');
    indirect->unimport(':fatal');
    multidimensional->unimport();
    bareword::filehandles->unimport();
    Sub::StrictDecl->import();
    Function::Parameters->import();
    Moose::Autobox->import( into => $into );
    $class->$import({into => $into});
    MooseX::Types::Moose->import({into => $into} => MooseX::Types::Moose->type_names);
    MooseX::Types::Common::String->import({into => $into} => MooseX::Types::Common::String->type_names);
    MooseX::Types::Common::Numeric->import({into => $into} => MooseX::Types::Common::Numeric->type_names);
    MooseX::Types::ISO8601->import({into => $into} => MooseX::Types::ISO8601->type_names);
    MooseX::Types::Varchar->import({into => $into} => 'Varchar');
    MooseX::Types::LoadableClass->import({into => $into} => qw/LoadableClass LoadableRole/);
    MooseX::Types::DateTime::MySQL->import({into => $into} => 'MySQLDateTime');
    namespace::autoclean->import(-cleanee => $into);
}

sub import {
    my $class = shift;
    my $into = caller;
    do_import(__PACKAGE__, $into, 'Moose');
}

1;

=head1 NAME

state51::Moose - Moose, the way I like it.

=head1 SYNOPSIS

    package state51::SomeClass;
    use state51::Moose;

=head1 DESCRIPTION

Applies L<Moose>, L<Moose::Util::TypeConstraints>, L<Function::Parameters>, L<Moose::Autobox>
and L<namespace::autoclean> to the class using it.

=cut


