package state51::Moose::Role;
use strict;
use warnings;

use state51::Moose ();

sub import {
    my $class = shift;
    my $into = caller;
    state51::Moose::do_import(__PACKAGE__, $into, 'Moose::Role');
}

1;

=head1 NAME

state51::Moose::Role - Moose::Role, the way I like it.

=head1 SYNOPSIS

    package state51::SomeClass;
    use state51::Moose::Role;

=head1 DESCRIPTION

Applies L<Moose::Role>, L<Moose::Util::TypeConstraints>, L<Function::Parameters>, L<Moose::Autobox>
and L<namespace::autoclean> to the class using it.

=cut

