package state51::PidFileIfRoot;
use strict;
use warnings;
use Carp qw/ confess /;

sub import {
    my ($self) = @_;
    return unless ($< == 0);
    my $cmd = $0;
    return unless $cmd =~ s{/usr/bin/}{};
    $cmd =~ s{\.pl$}{};
    $cmd =~ s{\W+}{}g;
    my $fn = "/var/run/${cmd}.pid";
    if (-f $fn) {
        open(my $fh, '<', $fn) or confess $!;
        my $pid = <$fh>;
        chomp($pid);
        if (length($pid) && $pid =~ /^\d+$/ && kill(0, $pid)) {
            print STDERR "Not starting $0 ($cmd) as pid file $fn exists, as does $pid\n";
            exit 0;
        }
    }
    unlink $fn;
    open(my $fh, ">", $fn) or confess $!;
    print $fh $$ . "\n";
    close($fh);
}

1;

