
use strict;
use warnings;

use Test::More;
use Test::Exception;

use state51::Types::DateApproximate;

my $a = state51::Types::DateApproximate->new('1974-06');
cmp_ok($a, 'eq', '1974-06', 'echo 1974-06');
cmp_ok($a->is_approximate, '==', 0, '1974-06 is not approximate');

my $b = state51::Types::DateApproximate->new('1978');
cmp_ok($b, 'eq', '1978', 'echo 1978');
cmp_ok($b->is_approximate, '==', 1, '1978 is approximate');

my $c = state51::Types::DateApproximate->new('1973-08-07');
cmp_ok($c, 'eq', '1973-08-07', 'echo 1973-08-07');
cmp_ok($c->is_approximate, '==', 0, '1973-08-07 is not approximate');

my $d = state51::Types::DateApproximate->new('1973-8-7');
cmp_ok($d, 'eq', '1973-08-07', 'not quite echo 1973-8-7');

dies_ok { my $e = state51::Types::DateApproximate->new('1973-1-32') } 'invalid date dies';

dies_ok { my $f = state51::Types::DateApproximate->new('1973-13') } 'invalid date dies';

dies_ok { my $g = state51::Types::DateApproximate->new() } 'makes no sense without a date';

my $h = state51::Types::DateApproximate->new('2030-05-23');
my $i = state51::Types::DateApproximate->new($h->stringify);
cmp_ok($i, 'eq', '2030-05-23', 'initialised from the stringification of another');

done_testing();

1;
