package TestJob;

use Moose;
use strict;
use warnings;

use MooseX::Types::Moose qw/ Str Num /;
use Sys::Hostname ();

with qw/
    Log::Message::Structured
    Log::Message::Structured::Stringify::AsJSON
/;

sub freeze { &as_string }

has file_to_poke => (
    isa => Str,
    is  => 'ro',
    required => 1,
);

has wait_for => (
    isa => Num,
    is => 'ro',
    default => 0,
);

sub run {
    my ($self) = @_;
    print STDERR "# ".ref($self)." running: ".$self->file_to_poke."\n";

    sleep $self->wait_for() if $self->wait_for > 0;

    open(my $fh, ">>", $self->file_to_poke) or die $!;
    print $fh "HELLO WORLD!\n";
    close $fh;
    return;
}

sub exchange_name { "test-".Sys::Hostname::hostname()."-fsqqq9" };

1;
