
use strict;
use warnings;

use Test::More;
use Test::Exception;

{
    package Foo;
    use Moose;
    use state51::Types::VarcharBytes qw/ VarcharBytes /;
    use MooseX::Types::Varchar qw/ Varchar /;
    has b => (
        isa => VarcharBytes[2],
        is  => 'rw',
    );

    has a => (
        isa => Varchar[2],
        is  => 'rw'
    );

    __PACKAGE__->meta->make_immutable();
}


my $foo = Foo->new();

lives_ok { $foo->b("xx"); };
dies_ok  { $foo->b("xxx"); };

lives_ok { $foo->b("\xff"); };
dies_ok { $foo->b("x\xff"); };

my $y = "x\xff";

ok !utf8::is_utf8($y);
dies_ok { $foo->b($y) };
utf8::upgrade($y);
dies_ok { $foo->b($y) };

my $z = "\xff";
ok !utf8::is_utf8($z);
lives_ok { $foo->b($z) };
ok(!utf8::is_utf8($foo->b), "string was not upgraded to utf8 by typecontraint");

utf8::upgrade($z);
lives_ok { $foo->b($z) };
ok(utf8::is_utf8($foo->b), "utf8 flag preserved by typeconstraint");

is($foo->b, $z, "string unscatched");

done_testing();

1;
